/* Hack. Because included in a .c file !!!!!!!!!!!!!!!!!!!!!!1 :-(
 */
#define RNBBY   8
#define MAXKEYBITS      (SOCK_MAXADDRLEN * RNBBY)
#define MAXDEPTH        (MAXKEYBITS+1)

typedef struct _radix_node {
    struct _radix_node  *rnode_left;            /* child when bit clear */
    struct _radix_node  *rnode_right;           /* child when bit set */
    struct _radix_node  *rnode_parent;          /* parent */
    u_short     rnode_bit;                      /* bit number for node/mask */
    u_char      rnode_tbyte;                    /* byte to test in address */
    u_char      rnode_tbit;                     /* bit to test in byte */
    rt_head     *rnode_rth;                     /* our external info */
} radix_node;

typedef struct _rt_table {
    struct _rt_table    *rt_table_next; /* next table in list */
    radix_node  *rt_table_tree;         /* current root of tree */
    struct sock_info *rt_table_sinfo;   /* stuff we need to grok sockaddr's */
    u_long      rt_table_inodes;        /* number of internal nodes in tree */
    u_long      rt_table_routes;        /* number of routes in tree */
} rt_table;


#define PORT_TASK_NAME		"PORT_TASK_NAME"
#define PORT_DEFAULT_PORT	7667
#define SKIPFIRST	1
#define NOSKIPFIRST	0

typedef struct _rt_walk_save {
	int af;
	radix_node *head;
	rt_table *Xrt_table;
	radix_node *Xstack[MAXDEPTH];
	radix_node **Xsp;
	radix_node *Xrn;
} rt_walk_save;

#define	RT_TABLES_GLOBAL(af, Xrt_table, skipfirst) \
    do { \
	for (if ((skipfirst) == SKIPFIRST && (Xrt_table)) \
			(Xrt_table) = (Xrt_table)->rt_table_next; \
	     (Xrt_table); \
	     (Xrt_table) = (Xrt_table)->rt_table_next) { \
	    af = (Xrt_table)->rt_table_sinfo->si_family;

#define	RT_TABLES_GLOBAL_END(skipfirst) \
	    (skipfirst) = 0; \
	} \
    } while (0)

#define	RT_WALK_GLOBAL(head, rth, Xstack, Xsp, Xrn, skipfirst) \
    do { \
	while (Xrn) { \
	    if ((skipfirst) == SKIPFIRST && ((rth) = Xrn->rnode_rth)) do

#define	RT_WALK_END_GLOBAL(head, rth, Xstack, Xsp, Xrn, skipfirst) \
	    while (0); \
	    (skipfirst) = 0; \
	    if (Xrn->rnode_left) { \
		if (Xrn->rnode_right) { \
		    *Xsp++ = Xrn->rnode_right; \
		} \
		Xrn = Xrn->rnode_left; \
	    } else if (Xrn->rnode_right) { \
		Xrn = Xrn->rnode_right; \
	    } else if (Xsp != Xstack) { \
		Xrn = *(--Xsp); \
	    } else { \
		Xrn = (radix_node *) 0; \
		(rth) = (rt_head *) 0; \
	    } \
	} \
    } while (0)

void port_init();
void port_task_dump();
void port_listen_accept();
void port_bg_rt_dump();
void port_dump_job();
void port_dump_rth();
rt_head *rt_radix_first();
rt_head *rt_radix_next();
